Berkeley DB version 5.3.15

## com.sleepycat.bind.serial
Class TupleSerialKeyCreator<D>

    java.lang.Object
      com.sleepycat.bind.tuple.TupleBase
          com.sleepycat.bind.serial.TupleSerialKeyCreator<D>

All Implemented Interfaces:
  ForeignKeyNullifier, SecondaryKeyCreator

Direct Known Subclasses:
  TupleSerialMarshalledKeyCreator

    public abstract class TupleSerialKeyCreator<D>

extends TupleBase
implements SecondaryKeyCreator, ForeignKeyNullifier

A abstract key creator that uses a tuple key and a serial data entry. This class takes care of serializing and deserializing the data entry, and converting the key entry to/from `TupleInput` and `TupleOutput` objects. The following abstract method must be implemented by a concrete subclass to create the index key using these objects

- `createSecondaryKey(TupleInput,Object,TupleOutput)`

If `ForeignKeyDeleteAction.NULLIFY` was specified when opening the secondary database, the following method must be overridden to nullify the foreign index key. If NULLIFY was not specified, this method need not be overridden.

- `nullifyForeignKey(Object)`

See Also:
  Class Evolution

Field Summary
`protected SerialBinding<D>` `dataBinding`

Constructor Summary
`TupleSerialKeyCreator(ClassCatalog classCatalog, Class<D> dataClass)` Creates a tuple-serial key creator.
`TupleSerialKeyCreator(SerialBinding<D> dataBinding)` Creates a tuple-serial key creator.

Method Summary
`boolean` `createSecondaryKey(SecondaryDatabase db, DatabaseEntry primaryKeyEntry, DatabaseEntry dataEntry, DatabaseEntry indexKeyEntry)` Creates a secondary key entry, given a primary key and data entry.
`abstract boolean` `createSecondaryKey(TupleInput primaryKeyInput, D dataInput, TupleOutput indexKeyOutput)` Creates the index key entry from primary key tuple entry and deserialized data entry.
`D` `nullifyForeignKey(D data)` Clears the index key in the deserialized data entry.
`boolean` `nullifyForeignKey(SecondaryDatabase db, DatabaseEntry dataEntry)` Sets the foreign key reference to null in the datum of the primary database.

Methods inherited from class com.sleepycat.bind.tuple.TupleBase
`entryToInput, getTupleBufferSize, getTupleOutput, inputToEntry, newOutput, newOutput, outputToEntry, setTupleBufferSize`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### dataBinding

    protected SerialBinding<D> dataBinding

Constructor Detail

### TupleSerialKeyCreator

    public TupleSerialKeyCreator(ClassCatalog classCatalog,
                                 Class<D> dataClass)

  Creates a tuple-serial key creator.

  Parameters:
    `classCatalog` - is the catalog to hold shared class information and for a database should be a `StoredClassCatalog`.
    `dataClass` - is the data base class.

### TupleSerialKeyCreator

    public TupleSerialKeyCreator(SerialBinding<D> dataBinding)

  Creates a tuple-serial key creator.

  Parameters:
    `dataBinding` - is the data binding.

Method Detail

### createSecondaryKey

    public boolean createSecondaryKey(SecondaryDatabase db,
                                      DatabaseEntry primaryKeyEntry,
                                      DatabaseEntry dataEntry,
                                      DatabaseEntry indexKeyEntry)

  Description copied from interface: `SecondaryKeyCreator`
  Creates a secondary key entry, given a primary key and data entry.

  A secondary key may be derived from the primary key, primary data, or a combination of the primary key and data. For secondary keys that are optional, the key creator method may return false and the key/data pair will not be indexed. To ensure the integrity of a secondary database the key creator method must always return the same result for a given set of input parameters.

  Specified by:
    `createSecondaryKey` in interface `SecondaryKeyCreator`
  Parameters:
    `db` - the database to which the secondary key will be added. This parameter is passed for informational purposes but is not commonly used.

    `primaryKeyEntry` - the primary key entry. This parameter must not be modified by this method.

    `dataEntry` - the primary data entry. This parameter must not be modified by this method.

    `indexKeyEntry` - the secondary key created by this method.

  Returns:
    true if a key was created, or false to indicate that the key is not present.

### nullifyForeignKey

    public boolean nullifyForeignKey(SecondaryDatabase db,
                                     DatabaseEntry dataEntry)

  Description copied from interface: `ForeignKeyNullifier`
  Sets the foreign key reference to null in the datum of the primary database.

  Specified by:
    `nullifyForeignKey` in interface `ForeignKeyNullifier`
  Parameters:
    `db` - the database in which the foreign key integrity constraint is defined. This parameter is passed for informational purposes but is not commonly used.
    `dataEntry` - the existing primary datum in which the foreign key reference should be set to null. This parameter should be updated by this method if it returns true.
  Returns:
    true if the datum was modified, or false to indicate that the key is not present.

### createSecondaryKey

    public abstract boolean createSecondaryKey(TupleInput primaryKeyInput,
                                               D dataInput,
                                               TupleOutput indexKeyOutput)

  Creates the index key entry from primary key tuple entry and deserialized data entry.

  Parameters:
    `primaryKeyInput` - is the `TupleInput` for the primary key entry, or null if no primary key entry is used to construct the index key.
    `dataInput` - is the deserialized data entry, or null if no data entry is used to construct the index key.
    `indexKeyOutput` - is the destination index key tuple. For index keys which are optionally present, no tuple entry should be output to indicate that the key is not present or null.
  Returns:
    true if a key was created, or false to indicate that the key is not present.

### nullifyForeignKey

    public D nullifyForeignKey(D data)

  Clears the index key in the deserialized data entry.

  On entry the data parameter contains the index key to be cleared. It should be changed by this method such that `createSecondaryKey(com.sleepycat.db.SecondaryDatabase, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry)` will return false. Other fields in the data object should remain unchanged.

  Parameters:
    `data` - is the source and destination deserialized data entry.
  Returns:
    the destination data object, or null to indicate that the key is not present and no change is necessary. The data returned may be the same object passed as the data parameter or a newly created object.

Berkeley DB version 5.3.15

Copyright (c) 1996, 2011 Oracle and/or its affiliates. All rights reserved.